<template>
  <div class="w-100 h-100" v-bind:style="mapContainerStyle">
    <slot v-if="ready">
      <!-- map controls -->
      <map-control position="topleft">
        <pressure-level-control/>
        <query-control v-on:toggle-crosshair="toggleCrosshair()"/>
      </map-control>


      <!-- basemap and coastlines -->
      <map-pane name="basemap" :zindex="190">
        <tile-layer :url="$store.state.defaultBasemap"></tile-layer>
      </map-pane>
      <map-pane name="borders" :zindex="300">
        <wms-layer
          url="http://mapservices.ipma.pt/common/boundaries/wms"
          name="coastlines"/>
      </map-pane>

      <!-- panes and WMS layers -->
      <map-pane v-for="pane in panes" :key="pane.uniqueId" :name="pane.name" :zindex="pane.zindex">
        <wms-time-layer v-for="layer in paneLayers(pane)" :key="layer.uniqueId" :layerId="layer.uniqueId"/>
      </map-pane>

      <!-- stations -->
      <geo-json-layer v-for="station in stationsLayers()" :key="station.uniqueId" :layerId="station.uniqueId"/>

      <!-- location markers -->
      <location-marker v-for="location in locations" :key="location.uniqueId" :locationId="location.uniqueId"/>

      <!-- custom location marker -->
      <template v-if="customLocation">
        <custom-location-marker/>
      </template>
    </slot>
  </div>
</template>

<script>
import uuid from 'uuid'
import { map } from 'leaflet'
import { EventBus } from '@/bus'
import { ADD_WORKSPACE_CUSTOM_LOCAL, REMOVE_WORKSPACE_CUSTOM_LOCAL } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LeafletProvider from '@/workspace/mixins/LeafletProvider'
import MapPane from '@/workspace/components/map/MapPane'
import TileLayer from '@/workspace/components/map/TileLayer'
import WmsLayer from '@/workspace/components/map/WmsLayer'
import WmsTimeLayer from '@/workspace/components/map/WmsTimeLayer'
import MapControl from '@/workspace/components/map/MapControl'
import PressureLevelControl from '@/workspace/components/map/PressureLevelControl'
import QueryControl from '@/workspace/components/map/QueryControl'
import LocationMarker from '@/workspace/components/map/LocationMarker'
import CustomLocationMarker from '@/workspace/components/map/CustomLocationMarker'
import GeoJsonLayer from '@/workspace/components/map/GeoJSONLayer'

export default {
  name: 'workspacemap',

  mixins: [
    WorkspaceGetter,
    LeafletProvider,
  ],

  data() {
    return {
      ready: false,
      crosshair: false,
      externalMove: false
    }
  },

  computed: {
    linked: {
      get () {
        return this.$store.getters.linked
      }
    },

    panes: {
      get() {
        return this.$store.getters.workspacePanes(this.workspaceId)
      }
    },

    locations: {
      get() {
        return this.$store.getters.workspaceLocations(this.workspaceId).filter(l => {
          return l.groups.length > 0
        })
      }
    },

    customLocation: {
      get() {
        return this.$store.getters.workspaceCustomLocation(this.workspaceId)
      }
    },

    mapContainerStyle: {
      get() {
        return {
          cursor: this.crosshair ? 'crosshair' : 'auto'
        }
      }
    }
  },

  methods: {
    paneLayers(pane) {
      return this.$store.getters.workspaceLayers(this.workspaceId).filter(layer => {
        return layer.pane === pane.id
      })
    },

    stationsLayers () {
      return this.$store.getters.workspaceLayers(this.workspaceId).filter(layer => {
        return 'type' in layer && layer.type === 1
      })
    },

    toggleCrosshair() {
      this.crosshair = !this.crosshair
    },

    _getMapOptions() {
      return {
        zoom: 6,
        minZoom: 4,
        maxZoom: 12,
        center: [37.5, -16]
      }
    },

    setZoom (value) {
      this.__leafletMap.setZoom(value, { animate: false })
    },

    setView (center, zoom) {
      this.externalMove = true
      this.__leafletMap.setView(center, zoom, {
        animate: false,
        noMoveStart: true
      })
      this.externalMove = false
    }
  },

  mounted() {

    this.__leafletMap = map(this.$el, this._getMapOptions())

    this.__leafletMap.on('zoom', (ev) => {
      if(!this.externalMove) {
        EventBus.$emit('workspace-map-move', {
          center: ev.target.getCenter(),
          zoom: ev.target.getZoom()
        })
      }
    })

    this.__leafletMap.on('move', (ev) => {
      if(!this.externalMove) {
        EventBus.$emit('workspace-map-move', {
          center: ev.target.getCenter(),
          zoom: ev.target.getZoom()
        })
      }
    })

    this.__leafletMap.on('click', (ev) => {
      if(this.crosshair) {
        this.$store.commit(REMOVE_WORKSPACE_CUSTOM_LOCAL, {
          workspaceId: this.workspaceId,
        })

        this.$nextTick(() => {
          this.$store.commit(ADD_WORKSPACE_CUSTOM_LOCAL, {
            workspaceId: this.workspaceId,
            location: {
              uniqueId: uuid(),
              latitude: ev.latlng.lat,
              longitude: ev.latlng.lng
            }
          })
          this.toggleCrosshair()
        })
      }
    })
    
    EventBus.$on('reload-map-size', () => {
      this.$nextTick(() => { this.__leafletMap.invalidateSize(false) })
    })

    EventBus.$on('workspace-map-move', (payload) => {
      if(this.linked) {
        this.setView(payload.center, payload.zoom)
      }
    })

    this.ready = true
  },

  components: {
    MapPane,
    TileLayer,
    WmsLayer,
    WmsTimeLayer,
    MapControl,
    PressureLevelControl,
    QueryControl,
    LocationMarker,
    CustomLocationMarker,
    GeoJsonLayer,
  }
}
</script>
